#include <allegro.h>
#include <stddef.h>
#include <ctype.h>

static int tab_size = 0;                  /* size to consider tabs as */

static long get_word(char *string);     /* returns size of next word*/

void set_tab_size(long size)
{
      tab_size = size;
}
char *new_word_wrap(char *input,char *output, long line_len)
{
      long   len,                         /* length of current word */
             current_len = 0;             /* current length of line */
      long   start_line = 0;              /* index of beginning if line */

      int a = 0;

      while (0 != (len = get_word(&input[current_len + start_line])))
      {
            while (len > line_len)
            {
                  memcpy(&output[start_line+a],&input[start_line],current_len);
                  a++;
                  output[start_line+current_len+a] = '\n';
                  start_line += current_len + 1;
                  len-=(line_len-current_len);
                  current_len = 0;
            }
            if (current_len + len < line_len)
                  current_len += len;
            else
            {
                  memcpy(&output[start_line+a],&input[start_line],current_len);
                  output[start_line+current_len+a] = '\n';
                  start_line += current_len + 1;
                  current_len = 0;
            }
      }
      return output;


}
char *word_wrap(char *string, long line_len)
{
      long   len,                         /* length of current word */
             current_len = 0;             /* current length of line */
      long   start_line = 0;              /* index of beginning if line */

      while (0 != (len = get_word(&string[current_len + start_line])))
      {
            if (len < 0)
            {
                  start_line += current_len + 2 + (-len);
                  current_len = 0;
                  continue;
            }

            if (current_len + len < line_len)
                  current_len += len;
            else
            {
                  string[start_line+current_len] = '\n';
                  start_line += current_len + 1;
                  current_len = 0;
            }
      }
      return string;
}

static long get_word(char *string)
{
      register int i = 0, word_len = 0, n=0;

      if (!string[0])
            return 0;
      while (isspace(string[i]))
      {
            word_len++;
            if ('\t' == string[i])
            {
                  if (0 == tab_size)
                        string[i] = ' ';
                  else  word_len += tab_size-1;
            }
            else if ('\n' == string[i]&&n==0)
            {
                  string[i]=' ';
                  n++;
            }
            else if('\n' == string[i]&&n>0)
                  return -word_len;
            i++;
      }

      while (string[i] && !isspace(string[i++]))
            word_len++;
      return word_len;
}


void gtextout(BITMAP *bmp,FONT *font,char *s,int x,int y,int colour)
  {
  if(s==NULL) return;
  int max=strlen(s);
  char *temp=new char[max+10];
  int a=0,b=0,ll=0;
  temp[0]=0;

  while(a<max) {
    b=0;
    while(s[a]=='\n') {
      a++;
      ll++;
      }
    while(s[a]!='\n'&&a<max)
      temp[b++]=s[a++];
    temp[b]=0;
    textout(bmp,font,temp,x,y+ll*text_height(font),colour);
    }
  delete [] temp;
  }