#include <allegro.h>
#include <tdgui.h>
#include <jgmod.h>
#include <string.h>
#include <stdio.h>
#include <dos.h>
#include <seer.h>
#define BYTE unsigned char
#include "land.h"
#include "mapc.h"
#include "mobs.h"
#include "stars.h"
#include "g_wrap.h"
#define VERSION "MapGen 2.01"

#define GAME_SPEED 40

volatile BYTE sync;
volatile int stardate;

void sync_timer(...) {
  stardate++;
  sync++;
  }
END_OF_FUNCTION(sync_timer);

JGMOD *mf;

main(int argc,char **argv) {
  BITMAP *d;


  allegro_init();
  install_timer();
  install_mouse();
  install_keyboard();
  install_int(sync_timer,GAME_SPEED);
  int chn_reserved=0;

  mf=load_mod("map.dat#crystal");
  if(mf!=NULL) {
    if (mf->no_chn > 24)
        chn_reserved = 24;
    else
        chn_reserved = mf->no_chn;
    }

  reserve_voices (chn_reserved+8, -1);
  if(install_sound (DIGI_AUTODETECT, MIDI_NONE, NULL)) {
    printf("Sound error: %s\n",allegro_error);
    exit(-1);
    }

  if(install_mod(chn_reserved)<0)  // initialize soundcard
    {
    printf("Error : Unable to allocate %d voices.\n",chn_reserved);
    exit(-1);
    }
  else {
    set_mod_volume(128);
    play_mod(mf,TRUE);
    }

  char *text= VERSION
              "\n\nBy Nathan Smith\n\n"
              "I hope you like it. If you like, send in a donation plus your e-mail and I'll send\n"
              "you the full thing when its finished.\n"
              "This program uses:\n\n"
              "DJGPP v2\n"
              "Allegro "
              ALLEGRO_VERSION_STR
              " by Shawn Hargreaves\n\n"
              ;


  set_gfx_mode(GFX_AUTODETECT,320,240,0,0);
  text_mode(-1);


  d=create_bitmap(SCREEN_W,SCREEN_H);
  class land soltar;


  soltar.seed=0x04091979;  // 04/09/1979 My Birthday ;)
  soltar.type=0;
  soltar.size.x=100;
  soltar.size.y=100;
  soltar.hidden_areas=TRUE;
  soltar.check_pal();
  font=(FONT *)Mp_data[little].dat;

  gtextout(screen,font,word_wrap(text,40),0,30,255);
  
  soltar.go(d);

  if(mf!=NULL) destroy_mod(mf);                // free the mod
  destroy_bitmap(d);
  set_gfx_mode(GFX_TEXT,80,25,0,0);
  
  allegro_exit();
  printf("Bye");
  }
