//
//  Stuff for maps
//
//

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <allegro.h>
#include <math.h>

#include "map.h"

DATAFILE *Mp_data;        // Global Map Data

#define BYTE unsigned char
#define MAX_X SCREEN_W
#define MAX_Y SCREEN_H
#define rnd(x) (rand()%x)

flip();
display_map(BITMAP *d,BYTE *land,int cx,int cy,int sx,int sy);
display_dung(BITMAP *d,BYTE *land,int cx,int cy,int sx,int sy);

#ifdef rain
#undef rain
#endif

struct drop {
  int x,y,speed;
} rain[100];

int init_flag=0;
map_init()
  {
  if(init_flag==0) init_flag=1;
  else return -1;
  for(int a=0;a<100;a++)  {
    rain[a].x=rand()%320;
    rain[a].y=rand()%200;
    rain[a].speed=rand()%3+10;
    }

  Mp_data = load_datafile("map.dat");
  if(Mp_data==NULL) {
           allegro_exit();
           exit(-1);
                                    // We are in BIG trouble.
           }
  //set_palette((PALETTE)Mp_data[map_pal].dat);


  return 0;
  }

map_exit()
  {
  if(init_flag==1) init_flag=0;
  else return -1;
  unload_datafile(Mp_data);

  return 0;
  }

set_map_pal() {

  set_palette((PALETTE)Mp_data[map_pal].dat);
  }

int flp=0;

newdrop(int a) {
    if(flp==1) {
      flp=0;
      rain[a].x=rand()%320;
      rain[a].y=0;
      rain[a].speed=rand()%3+10;
      }
    else {
      flp=1;
      rain[a].y=rand()%200;
      rain[a].x=319;
      rain[a].speed=rand()%3+10;
      }
  }
do_rain(BITMAP *d) {   // draw rain function
  for(int b=0;b<100;b++) {             // move rain
    rain[b].x-=rain[b].speed;
    if(rain[b].x<0) newdrop(b);
    else {
      rain[b].y+=rain[b].speed;
      if(rain[b].y>200) newdrop(b);
      }
    }

                        // draw rain!

  for(int b=0;b<100;b++) {
    for(int c=0;c<rain[b].speed/2;c++)
      if(getpixel(d,rain[b].x-c,rain[b].y+c)> 0)
        _putpixel(d,rain[b].x-c,rain[b].y+c,176);
    for(int c=rain[b].speed/2;c<rain[b].speed-1;c++)
      if(getpixel(d,rain[b].x-c,rain[b].y+c)> 0)
        _putpixel(d,rain[b].x-c,rain[b].y+c,96);
    }
  }

void draw_pointer(BITMAP *d)
  {
  draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[pointer].dat,mouse_x,mouse_y);
  }

generate_dung(BYTE *land,int seed,int sx, int sy, int max_rooms)
  {
  srand(seed);
  int badroom=0;
  int rooms=0;
  memset(land,0,sx*sy);

  while(badroom<30&&rooms<max_rooms)
    {
    int x1=rand()%(sx-12)+1;
    int y1=rand()%(sy-12)+1;
    int xsize=3+rand()%8;
    int ysize=3+rand()%8;
    int x2=x1+xsize;
    int y2=y1+ysize;
    int check=TRUE; //assume room is OK now try to prove it false:
    for(int b=y1-1;b<=y2+1;b++) {
      int cb=b*sx;
      for(int a=x1-1;a<=x2+1;a++)
        if(land[cb+a]!=0)
          check=FALSE;      // There something else there!
      }
    if(check==FALSE) badroom++;
    else {
      rooms++;
      badroom=0;
      for(int b=y1;b<y2;b++) {
        int cb=b*sx;
        for(int a=x1;a<x2;a++)
          land[cb+a]=1;
        }

              // build passages to other rooms only if we are not the first
      if(rooms>1) {  // each room MUST be connected (ie if there was only one
                     // stairs down what would happen if it was unreachable?)
        int connection=FALSE; // first try easy connections but that doesn't work
                              // do it the hard way
        int exits=0;
        int pick=rand()%4;
        int cx,cy;
        while(exits<4) {
          switch (pick) {
            case 0:
              if(connection==TRUE&&!rand()%5) break;
              cy=(y1+ysize/2)*sx;
              for(int bb=x1-2;bb>=0;bb--) {
                if(land[bb+cy+sx]!=0||land[bb+cy-sx]!=0||land[bb+cy]!=0) { // found connection
                  connection=TRUE;
                  for(int c=x1;c>=bb;c--)
                    land[c+cy]=1;
                  break;
                  }
                }
              break;
            case 1:
              if(connection==TRUE&&!rand()%5) break;
              cy=sx*(y1+ysize/2);
              for(int bb=x2+2;bb<sx;bb++) {
                if(land[bb+cy+sx]!=0||land[bb+cy-sx]!=0||land[bb+cy]!=0) { // found connection
                  connection=TRUE;
                  for(int c=x2;c<=bb;c++)
                    land[c+cy]=1;
                  break;
                  }
                }
              break;
            case 2:
              if(connection==TRUE&&!rand()%5) break;
              cx=x1+xsize/2;
              for(int bb=y1-2;bb>=0;bb--) {
                if(land[bb*sx+cx+1]!=0||land[bb*sx+cx-1]!=0||land[bb*sx+cx]!=0) { // found connection
                  connection=TRUE;
                  for(int c=y1;c>=bb;c--)
                    land[(c*sx)+cx]=1;
                  break;
                  }
                }
              break;
            case 3:
              if(connection==TRUE&&!rand()%5) break;
              cx=(x1+xsize/2);
              for(int bb=y2+2;bb<sy;bb++) {
                if(land[bb*sx+cx-1]!=0||land[bb*sx+cx+1]!=0||land[bb*sx+cx]!=0) { // found connection
                  connection=TRUE;
                  for(int c=y2;c<=bb;c++)
                    land[c*sx+cx]=1;
                  break;
                  }
                }
              break;
            }
          exits++;
          pick=(pick+1)%4;
          }
        if(connection==FALSE) // If no connection remove room and try again
          {
          rooms--;
          for(int b=y1;b<y2;b++) {
            int cb=b*sx;
            for(int a=x1;a<x2;a++)
              land[cb+a]=0;
            }
          } // */
        else {  //put stuff in rooms:
          }
        }

      }
    }
  }
int tol(BYTE* land,int x,int y,int ymx,int mx,int my)
    {
    int t=land[ymx+x];
    if(x>0)
      {
      t+=land[ymx+x-1];
      if(y>0) t+=land[ymx+x-1-mx];
      if(y<my-1) t+=land[ymx+x-1+mx];
      }
    if(y>0) t+=land[ymx+x-mx];
    if(x<mx-1)
      {
      t+=land[ymx+x+1];
      if(y>0) t+=land[ymx+x+1-mx];
      if(y<my-1) t+=land[ymx+x+1+mx];
      }
    if(y<my-1) t+=land[ymx+x+mx];

    return t;
    }
generate_map(BYTE *land,int seed,int sx,int sy,int mass)
  {
  BYTE *map;

  map=new BYTE[sx*sy];
  srand(seed);
  memset(map,0,sx*sy);
  memset(land,0,sx*sy);
  int i,j;
  int landmass=0;

  int max;
  int back=20000; // My backup plan
  int cj=0;
  while(back>=0&&landmass<mass)
    {
    back--;
    hline(screen,0,0,(landmass*(MAX_X-1))/mass,190);
    landmass=0;

    for(j=0;j<5;j++)
      land[(rnd(sy))*sx+rnd(sx)]+=rnd(5)+1;

    for(cj=0,j=0;j<sy;cj+=sx,j++)
      for(i=0;i<sx;i++)
        {
        int total=tol(land,i,j,cj,sx,sy);
        map[cj+i]=total>>3;
        landmass+=map[cj+i];
        if(total>0) map[cj+i]+=rnd(2);
        }

    memcpy(land,map,sx*sy);

    }
  max=0;
  for(cj=0,j=0;j<sy;j++,cj+=sx)
    for(i=0;i<sx;i++)
      {
      int total=tol(land,i,j,cj,sx,sy);
      map[cj+i]=total/9;
      if(map[cj+i]>max) max=map[cj+i];
      }

  hline(screen,0,0,(landmass*(MAX_X-1))/mass,190);
  max/=2;
  int flg=0;
  back=200000;
  while(back>=0&&flg==0) { flg=1;
  back--;
  for(cj=0,j=0;j<sy;j++,cj+=sx)
    {
    
    for(i=0;i<sx;i++)
      {
      if(map[cj+i]==0)
        {
        if(i-1>=0&&map[cj+i-1]>0)
          {
          if(i+1<sx&&map[cj+i+1]>0)
            {
            if(j-1>=0&&map[cj+i-sx]>0)
              {
              if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waternsew;
              else land[cj+i]=waternew;
              }
            else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=watersew;
            else land[cj+i]=waterew;
            }
          else if(j-1>=0&&map[cj+i-sx]>0)
            {
            if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waternsw;
            else land[cj+i]=waternw;
            }
          else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=watersw;
          else land[cj+i]=waterw;
          }
        else if(i+1>=0&&map[cj+i+1]>0)
          {
          if(j-1>=0&&map[cj+i-sx]>0)
            {
            if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waternse;
            else land[cj+i]=waterne;
            }
          else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waterse;
          else land[cj+i]=watere;
          }
        else if(j-1>=0&&map[cj+i-sx]>0)
          {
          if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waterns;
          else land[cj+i]=watern;
          }
        else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waters;
        else land[cj+i]=water1;
        }
      else if(float(map[cj+i])<=(float(max)*2)/3) land[cj+i]=grass1+map[cj+i]%2;
      else if(map[cj+i]>0) {
      if(map[cj+i-1]<=max*2/3)
          {
          if(map[cj+i+1]<=max*2/3)
           {
           if(map[cj+i-sx]<=max*2/3)
             {
              if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
              else {map[cj+i]=1;flg=0;}
              }
            else if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
            else {map[cj+i]=1;flg=0;}
            }
          else if(map[cj+i-sx]<=max*2/3)
            {
            if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
            else land[cj+i]=treesnw;
            }
          else if(map[cj+i+sx]<=max*2/3) land[cj+i]=treessw;
          else land[cj+i]=treesw;
          }
        else if(map[cj+i+1]<=max*2/3)
          {
          if(map[cj+i-sx]<=max*2/3)
            {
            if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
            else land[cj+i]=treesne;
            }
          else if(map[cj+i+sx]<=max*2/3) land[cj+i]=treesse;
          else land[cj+i]=treese;
          }
        else if(map[cj+i-sx]<=max*2/3)
          {
          if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
          else land[cj+i]=treesn;
          }
        else if(map[cj+i+sx]<=max*2/3) land[cj+i]=treess;
        else land[cj+i]=trees1;
        }

      else if(map[cj+i]<=max)
        {
        if(map[cj+i-1]<=max)
          {
          if(map[cj+i+1]<=max)
            {
            if(map[cj+i-sx]<=max)
              {
              if(map[cj+i+sx]<=max) land[cj+i]=dirtnsew;
              else land[cj+i]=dirtnew;
              }
            else if(map[cj+i+sx]<=max) land[cj+i]=dirtsew;
            else land[cj+i]=dirtew;
            }
          else if(map[cj+i-sx]<=max)
            {
            if(map[cj+i+sx]<=max) land[cj+i]=dirtnsw;
            else land[cj+i]=dirtnw;
            }
          else if(map[cj+i+sx]<=max) land[cj+i]=dirtsw;
          else land[cj+i]=dirtw;
          }
        else if(map[cj+i+1]<=max)
          {
          if(map[cj+i-sx]<=max)
            {
            if(map[cj+i+sx]<=max) land[cj+i]=dirtnse;
            else land[cj+i]=dirtne;
            }
          else if(map[cj+i+sx]<=max) land[cj+i]=dirtse;
          else land[cj+i]=dirte;
          }
        else if(map[cj+i-sx]<=max)
          {
          if(map[cj+i+sx]<=max) land[cj+i]=dirtns;
          else land[cj+i]=dirtn;
          }
        else if(map[cj+i+sx]<=max) land[cj+i]=dirts;
        else land[cj+i]=dirt1+(map[cj+i]-max)%3;
        }
      }

    }
  }
  delete map;
  return 0;
  }
do_square(BYTE *land,int x1,int y1,int x2,int y2,int sx,double r,double h) {
  int x=int(r);
  if(x==0) x=1;
  int t;
  if(x2>x1) {t=x1;x1=x2;x2=t;}
  if(y2>y1) {t=y1;y1=y2;y2=t;}
  if(x1==x2-1&&y1==y2-1) return TRUE;
  if(x1==x2&&y1==y2) return TRUE;
  int p1=land[x1+y1*sx];
  int p2=land[x1+y2*sx];
  int p3=land[x2+y1*sx];
  int p4=land[x2+y2*sx];
  int x3=(x1+x2)>>1;
  int y3=(y1+y2)>>1;

  land[x3+y3*sx]=((p1+p2+p3+p4)>>2)+rand()%x; // do points
  land[x3+y1*sx]=((p1+p3)>>1)+rand()%x;
  land[x3+y2*sx]=((p2+p4)>>1)+rand()%x;
  land[x1+y3*sx]=((p1+p2)>>1)+rand()%x;
  land[x2+y3*sx]=((p3+p4)>>1)+rand()%x;

  r*=h;
  do_square(land,x1,y1,x3,y3,sx,r,h);
  do_square(land,x3,y3,x2,y2,sx,r,h);
  do_square(land,x3,y1,x2,y3,sx,r,h);
  do_square(land,x1,y3,x3,y2,sx,r,h);
  }
generate_frac_map(BYTE *land,int seed,int sx,int sy,double h) {
  srand(seed);
  memset(land,0,sx*sy);
  BYTE *map=new BYTE[sx*sy];
  memset(map,0,sx*sy);
  if(h<0) h=0;
  if(h>1) h=1;
  h=pow2(-h);
  do_square(land,0,0,sx,sy,sx,16,h);

  int max=0;
  int cj,j,i;
  for(cj=0,j=0;j<sy;j++,cj+=sx)
    for(i=0;i<sx;i++)
      {
      int total=tol(land,i,j,cj,sx,sy);
      map[cj+i]=total/9;
      if(map[cj+i]>max) max=map[cj+i];
      }

  max/=2;
  int flg=0;
  int back=200000;
  while(back>=0&&flg==0) { flg=1;
  back--;
  for(cj=0,j=0;j<sy;j++,cj+=sx)
    {
    
    for(i=0;i<sx;i++)
      {
      if(map[cj+i]==0)
        {
        if(i-1>=0&&map[cj+i-1]>0)
          {
          if(i+1<sx&&map[cj+i+1]>0)
            {
            if(j-1>=0&&map[cj+i-sx]>0)
              {
              if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waternsew;
              else land[cj+i]=waternew;
              }
            else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=watersew;
            else land[cj+i]=waterew;
            }
          else if(j-1>=0&&map[cj+i-sx]>0)
            {
            if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waternsw;
            else land[cj+i]=waternw;
            }
          else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=watersw;
          else land[cj+i]=waterw;
          }
        else if(i+1>=0&&map[cj+i+1]>0)
          {
          if(j-1>=0&&map[cj+i-sx]>0)
            {
            if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waternse;
            else land[cj+i]=waterne;
            }
          else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waterse;
          else land[cj+i]=watere;
          }
        else if(j-1>=0&&map[cj+i-sx]>0)
          {
          if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waterns;
          else land[cj+i]=watern;
          }
        else if(j+1<sy&&map[cj+i+sx]>0) land[cj+i]=waters;
        else land[cj+i]=water1;
        }
      else if(float(map[cj+i])<=(float(max)*2)/3) land[cj+i]=grass1+map[cj+i]%2;
      else if(map[cj+i]>0) {
      if(map[cj+i-1]<=max*2/3)
          {
          if(map[cj+i+1]<=max*2/3)
           {
           if(map[cj+i-sx]<=max*2/3)
             {
              if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
              else {map[cj+i]=1;flg=0;}
              }
            else if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
            else {map[cj+i]=1;flg=0;}
            }
          else if(map[cj+i-sx]<=max*2/3)
            {
            if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
            else land[cj+i]=treesnw;
            }
          else if(map[cj+i+sx]<=max*2/3) land[cj+i]=treessw;
          else land[cj+i]=treesw;
          }
        else if(map[cj+i+1]<=max*2/3)
          {
          if(map[cj+i-sx]<=max*2/3)
            {
            if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
            else land[cj+i]=treesne;
            }
          else if(map[cj+i+sx]<=max*2/3) land[cj+i]=treesse;
          else land[cj+i]=treese;
          }
        else if(map[cj+i-sx]<=max*2/3)
          {
          if(map[cj+i+sx]<=max*2/3) {flg=0;map[cj+i]=1;}
          else land[cj+i]=treesn;
          }
        else if(map[cj+i+sx]<=max*2/3) land[cj+i]=treess;
        else land[cj+i]=trees1;
        }

      else if(map[cj+i]<=max)
        {
        if(map[cj+i-1]<=max)
          {
          if(map[cj+i+1]<=max)
            {
            if(map[cj+i-sx]<=max)
              {
              if(map[cj+i+sx]<=max) land[cj+i]=dirtnsew;
              else land[cj+i]=dirtnew;
              }
            else if(map[cj+i+sx]<=max) land[cj+i]=dirtsew;
            else land[cj+i]=dirtew;
            }
          else if(map[cj+i-sx]<=max)
            {
            if(map[cj+i+sx]<=max) land[cj+i]=dirtnsw;
            else land[cj+i]=dirtnw;
            }
          else if(map[cj+i+sx]<=max) land[cj+i]=dirtsw;
          else land[cj+i]=dirtw;
          }
        else if(map[cj+i+1]<=max)
          {
          if(map[cj+i-sx]<=max)
            {
            if(map[cj+i+sx]<=max) land[cj+i]=dirtnse;
            else land[cj+i]=dirtne;
            }
          else if(map[cj+i+sx]<=max) land[cj+i]=dirtse;
          else land[cj+i]=dirte;
          }
        else if(map[cj+i-sx]<=max)
          {
          if(map[cj+i+sx]<=max) land[cj+i]=dirtns;
          else land[cj+i]=dirtn;
          }
        else if(map[cj+i+sx]<=max) land[cj+i]=dirts;
        else land[cj+i]=dirt1+(map[cj+i]-max)%3;
        }
      }

    }
  }

  delete [] map;
  }

/* Generate Maze - Algorithm from Paul Hart's Web Page */
void makemaze(BYTE *maze,int x, int y,int sx,int sy)
  {
  int p = 0, d[4];

  maze[x+y*sx] = 1;
  if ((x > 1) && (maze[(x - 2)+y*sx] == 0)) d[p++] = 1;
  if ((y > 1) && (maze[x+sx*(y - 2)] == 0)) d[p++] = 2;
  if ((x < (sx - 2)) && (maze[(x + 2)+sx*y] == 0)) d[p++] = 3;
  if ((y < (sy - 2)) && (maze[x+sx*(y + 2)] == 0)) d[p++] = 4;
  if (!p) return;
  p = d[rnd(p)];
  switch (p)
    {
    case 1: maze[(x - 1)+sx*y] = 1; makemaze(maze,x - 2, y,sx,sy); break;
    case 2: maze[x+sx*(y - 1)] = 1; makemaze(maze,x, y - 2,sx,sy); break;
    case 3: maze[(x + 1)+sx*y] = 1; makemaze(maze,x + 2, y,sx,sy); break;
    case 4: maze[x+sx*(y + 1)] = 1; makemaze(maze,x, y + 2,sx,sy); break;
    }
  makemaze(maze,x, y,sx,sy);
  }

gen_maze(BYTE *land,int seed,int sx,int sy)
  {
  if(sx%2==0||sy%2==0) return -1; // The size MUST be odd.
  srand(seed);

  memset(land,0,sx*sy);
  makemaze(land,1, 1,sx,sy);
  return 0;
  }
                  // Display a layered map with: scrolling pixel by pixel!
display_layered_map(BITMAP *d,BYTE *land1,BYTE *land2,BYTE *land3,int cx,int cy,int sx,int sy)
  {
  int stx=int(cx>>5); // top tile row
  int sty=int(cy>>5); // left tile col
  int etx=int(((cx+MAX_X)>>5)+1); // bottom tile row
  int ety=int(((cy+MAX_Y)>>5)+1); // right tile col
  if(stx<0) stx=0;      //  Bounds checks.
  if(sty<0) sty=0;
  if(etx>sx) etx=sx;
  if(ety>sy) ety=sy;
  int t=(stx<<5)-cx;   // x position on screen of first tile to draw to.
  int c=(sty<<5)-cy;   // y position on screen of first tile to draw to.
  int cb=sty*sx+stx;   // tile in land array to start from
  int tt,ca;
  int ccc=c+((ety-sty)<<5);
  int cct=t+((etx-stx)<<5);
  c+=32;
  t+=32;
  ccc+=32;
  if(sy-ety>32) ccc+=32;
  cct+=32;
  disable();
  for(;c<ccc;cb+=sx,c+=32)
    for(ca=cb,tt=t; tt<cct;ca++,tt+=32)
      if(land1[ca]!=5) {
        draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[land1[ca]].dat,tt-((RLE_SPRITE *)Mp_data[land1[ca]].dat)->w,c-((RLE_SPRITE *)Mp_data[land1[ca]].dat)->h);
        if(land2[ca]!=5) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[land2[ca]].dat,tt-((RLE_SPRITE *)Mp_data[land2[ca]].dat)->w,c-((RLE_SPRITE *)Mp_data[land2[ca]].dat)->h);
        if(land3[ca]!=5) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[land3[ca]].dat,tt-((RLE_SPRITE *)Mp_data[land3[ca]].dat)->w,c-((RLE_SPRITE *)Mp_data[land3[ca]].dat)->h);
        }
  enable();
  }
                  // Display map with: scrolling pixel by pixel!
display_map(BITMAP *d,BYTE *land,int cx,int cy,int sx,int sy)
  {
  int stx=int(cx>>5); // top tile row
  int sty=int(cy>>5); // left tile col
  int etx=int(((cx+MAX_X)>>5)+1); // bottom tile row
  int ety=int(((cy+MAX_Y)>>5)+1); // right tile col
  if(stx<0) stx=0;      //  Bounds checks.
  if(sty<0) sty=0;
  if(etx>sx) etx=sx;
  if(ety>sy) ety=sy;
  int t=(stx<<5)-cx;   // x position on screen of first tile to draw to.
  int c=(sty<<5)-cy;   // y position on screen of first tile to draw to.
  int cb=sty*sx+stx;   // tile in land array to start from
  int tt,ca;
  int ccc=c+((ety-sty)<<5);
  int cct=t+((etx-stx)<<5);
  c+=32;
  t+=32;
  ccc+=64;
  cct+=32;
  for(;c<ccc;cb+=sx,c+=32)
    for(ca=cb,tt=t; tt<cct;ca++,tt+=32)
      if(land[ca]!=5)
        draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[land[ca]].dat,tt-((RLE_SPRITE *)Mp_data[land[ca]].dat)->w,c-((RLE_SPRITE *)Mp_data[land[ca]].dat)->h);



  }
                  // Display dungeon with: scrolling pixel by pixel!
display_dung(BITMAP *d,BYTE *land,int cx,int cy,int sx,int sy)
  {
  int stx=int(cx>>5)-1; // top tile row
  int sty=int(cy>>5)-1; // left tile col
  int etx=int(((cx+MAX_X)>>5)+.9999)+1; // bottom tile row
  int ety=int(((cy+MAX_Y)>>5)+.9999)+1; // right tile col
  if(stx<0) stx=0;      //  Bounds checks.
  if(sty<0) sty=0;
  if(etx>sx) etx=sx;
  if(ety>sy) ety=sy;
  int t=(stx<<5)-cx;   // x position on screen of first tile to draw to.
  int c=(sty<<5)-cy;   // y position on screen of first tile to draw to.
  int cb=sty*sx+stx;   // tile in land array to start from
  int tt,ca,a,b;
  for(a=sty;a<ety;a++,cb+=sx,c+=32)
    for(ca=cb,tt=t,b=stx; b<etx;ca++,b++,tt+=32)
      if(land[ca]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[dungfloor].dat,tt,c);
      else if(land[ca]==0){ // Here where we slow down the code!
        if(land[ca-1]==1||land[ca+1]==1||land[ca+sx]==1||land[ca-sx]==1) {
          if(b!=0&&land[ca-1]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallw].dat,tt,c);
          if(b!=sx&&land[ca+1]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[walle].dat,tt,c);
          if(a!=0&&land[ca-sx]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[walln].dat,tt,c);
          if(a!=sy&&land[ca+sx]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[walls].dat,tt,c);
          if(b!=0&&a!=0&&land[ca-1]==1&&land[ca-sx]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallnw].dat,tt,c);
          if(b!=sx&&a!=0&&land[ca+1]==1&&land[ca-sx]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallne].dat,tt,c);
          if(b!=0&&a!=sy&&land[ca-1]==1&&land[ca+sx]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallsw].dat,tt,c);
          if(b!=sx&&a!=sy&&land[ca+1]==1&&land[ca+sx]==1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallse].dat,tt,c);
          }
        if(land[ca-1-sx]==1||land[ca+1-sx]==1||land[ca-1+sx]==1||land[ca+1+sx]==1) {
          if(b!=0&&a!=0&&land[ca-1-sx]==1&&land[ca-1]!=1&&land[ca-sx]!=1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallcnw].dat,tt,c);
          if(b!=sx&&a!=0&&land[ca+1-sx]==1&&land[ca+1]!=1&&land[ca-sx]!=1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallcne].dat,tt,c);
          if(b!=0&&a!=sy&&land[ca-1+sx]==1&&land[ca-1]!=1&&land[ca+sx]!=1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallcsw].dat,tt,c);
          if(b!=sx&&a!=sy&&land[ca+1+sx]==1&&land[ca+1]!=1&&land[ca+sx]!=1) draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[wallcse].dat,tt,c);
          }
        }

  }





int stop,cux,cuy,six,siy;
BYTE *p1,*p2;
BITMAP *dumby;
void sight(BITMAP *dumby,int x,int y,int p) {
  if(stop==1) return;
  if(p1[x+y*six]==5) p1[x+y*six]=p2[x+y*six];

  if((p==0||p==3)&&stop>=0&&p2[x+y*six]==trees1) stop++;
  if(p!=0&&stop>=0&&p2[x+y*six]==0) stop++;

  if(stop<0) stop++;
  }
void round(BITMAP *dumby,int x,int y,int p) {
  stop=-1;
  do_line(dumby,cux,cuy,x,y,p,sight);
  }
int icu(BYTE *from,BYTE *showonme,int light,int x,int y,int sx,int sy,int pick) {
  int cx=x;
  int cy=y;
  six=sx;
  siy=sy;
  cux=cx;
  cuy=cy;
  p1=showonme;
  p2=from;
  int stx=x-(light-1);
  int sty=y-(light-1);
  int etx=x+light;
  int ety=y+light;
  if(stx>=sx) return -1;
  if(sty>=sy) return -1;
  if(etx<0) return -1;
  if(ety<0) return -1;

  if(light>1)
    do_circle(dumby,cx,cy,light,pick,round);
  else for(int b=cy-1;b<=cy+1;b++) {
       int cb=b*sx;
       if(b>=0&&b<=sy)
       for(int a=cx-1;a<=cx+1;a++)
         if(a>=0&&a<=sx&&showonme[cb+a]==5) showonme[cb+a]=from[cb+a];
    }
  return 0;
  }

