#define BYTE unsigned char
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <allegro.h>
#include <seer.h>
#include "mapc.h"
#include "land.h"
#include "mobs.h"

extern volatile BYTE sync;
extern volatile int stardate;

scScript orc;

//////////////////////////////// Pathfinding //////////////////////////////

int walk(BYTE square,int pick) {
  return (square!=5&&(((pick==3||pick==0)&&square<water1)||(pick!=0&&square!=0))); // This function changes depending on the map
                      // in question.
  }

int generate_path(BYTE *board,BYTE *em,vect from,vect to,vect size,int pick,path &p) {
  unsigned *map=new unsigned int[size.x*size.y];
  vect *curr_list=new vect[size.x*size.y];
  unsigned int *dist=new unsigned int[size.x*size.y];
  vect diff;
  int temp;
  unsigned int count;
  int i;
  int a,n;

  vect curr;

  int curr_list_count=1;
  int found_target=FALSE;

  int cx,cy,ccy,cccy;
  vect dir[8]={{-1,0},{1,0},{0,-1},{0,1},
               {-1,-1},{1,1},{1,-1},{-1,1}};
  int t=0;
      
  memset(map,-1,4*size.x*size.y);
  memset(dist,0,4*size.x*size.y);
  memset(curr_list,0,8*size.x*size.y);
  curr_list[0].x=from.x;
  curr_list[0].y=from.y;
  diff.x=from.x-to.x;
  diff.y=from.y-to.y;
  dist[0]=(diff.x*diff.x)+(diff.y*diff.y);
  map[from.x+from.y*size.x]=0;

  while(!found_target&&curr_list_count>0) {
       // Find next point:
    t=0;
    for(i=1;i<curr_list_count;i++)
      if(dist[i]<dist[t])
        t=i;
    curr.x=curr_list[t].x;
    curr.y=curr_list[t].y;
    curr_list_count--;
    curr_list[t].x=curr_list[curr_list_count].x;
    curr_list[t].y=curr_list[curr_list_count].y;
    dist[t]=dist[curr_list_count];
    cccy=curr.y*size.x+curr.x;
    count=map[cccy]+1;

    // Now add new points on:
    for(a=0;a<8;a++) {
      cx=curr.x+dir[a].x;
      cy=curr.y+dir[a].y;
      ccy=cccy+dir[a].x;
      if(dir[a].y<0) ccy-=size.x;
      else if(dir[a].y>0) ccy+=size.y;

      if(cx==to.x&&cy==to.y) found_target=TRUE;
           
      if(cx>=0&&
         cx<=size.x-1&&
         cy>=0&&
         cy<=size.y-1&&
         walk(board[ccy],pick)&&
         em[ccy]==5&&
         map[ccy]==(unsigned int)(-1)) { // Good square
           diff.x=cx-to.x;
           diff.y=cy-to.y;
           curr_list[curr_list_count].x=cx;
           curr_list[curr_list_count].y=cy;
           dist[curr_list_count++]=(diff.x*diff.x)+(diff.y*diff.y);
           map[ccy]=count;
           }

      }
    }
  delete [] curr_list;
  delete [] dist;
  if(!found_target) {   // didn't find it
    delete [] map;

    return FALSE;
    }
                        // We found it ! Trace back to form the path
  curr.x=to.x;
  curr.y=to.y;
  n=2;
  while(curr.x!=from.x||curr.y!=from.y) {
    t=0;
    count=(unsigned int)(-1);
    for(a=0;a<8;a++)
      if(!(curr.x+dir[a].x<0||
          curr.x+dir[a].x>=size.x||
          curr.y+dir[a].y<0||
          curr.y+dir[a].y>=size.y)&&
          count>map[curr.x+dir[a].x+(curr.y+dir[a].y)*size.x]) {
        t=a;
        count=map[curr.x+dir[a].x+(curr.y+dir[a].y)*size.x];
        }
    n++;
    curr.x+=dir[t].x;
    curr.y+=dir[t].y;
    }
  if(p.data!=NULL) delete [] p.data;
  p.data=new vect[n];
  p.length=n;
  n--;
  curr.x=to.x;
  curr.y=to.y;
  p.data[n].x=-1;
  p.data[n--].y=-1;
  p.data[n].x=to.x;
  p.data[n--].y=to.y;
  while(curr.x!=from.x||curr.y!=from.y) {
    t=0;
    count=(unsigned int)(-1);
    for(a=0;a<8;a++)
      if(!(curr.x+dir[a].x<0||
          curr.x+dir[a].x>=size.x||
          curr.y+dir[a].y<0||
          curr.y+dir[a].y>=size.y)&&
          count>map[curr.x+dir[a].x+(curr.y+dir[a].y)*size.x]) {
        t=a;
        count=map[curr.x+dir[a].x+(curr.y+dir[a].y)*size.x];
        }
    curr.x+=dir[t].x;
    curr.y+=dir[t].y;
    p.data[n].x=curr.x;
    p.data[n--].y=curr.y;
    }
  delete [] map;
  return TRUE;
  }
//////////////////////////////// Misc Tools /////////////////////////////

in_range(vect from,vect to,int range) { // Hey are these two in range?
  return (sqrt((from.x-to.x)*(from.x-to.x)+(from.y-to.y)*(from.y-to.y))<=range);
  }
//////////////////////////////// Items /////////////////////////////////////

item::dis(BYTE *d,int s,int i) {
  if(mob_holding==none) d[info.location.x+info.location.y*s]=pict+i%anim;

  return 0;
  }

//////////////////////////////// Mobs //////////////////////////////////////
int mob::total=0;

mob::do_stats() {
  if(current.attack<normal.attack)        current.attack++;
  else if(current.attack>normal.attack)   current.attack--;

  if(current.defence<normal.defence)      current.defence++;
  else if(current.defence>normal.defence) current.defence--;

  if(current.range<normal.range)          current.range++;
  else if(current.range>normal.range)     current.range--;

  if(current.skill<normal.skill)          current.skill++;
  else if(current.skill>normal.skill)     current.skill--;
  }
mob::dis(BYTE *d,int s) {
  if(location.x<0) return -1;
  if(location.y<0) return -1;
  if(location.x>s) return -1;
  if(location.y>s) return -1;
  d[location.x+location.y*s]=pict;
  return 0;
  }
mob::go_to(BYTE *board,BYTE *em,int pick,vect size) {
  if(target.x==dest.x&&target.y==dest.y) return -1;
  target.x=dest.x;
  target.y=dest.y;
  if(dest.y<0) return -1;
  if(dest.x<0) return -1;
  if(dest.x>=size.x) return -1;
  if(dest.y>=size.y) return -1;
  if(em[dest.x+dest.y*size.x]!=5) return -1;
  if(!walk(board[dest.x+dest.y*size.x],pick)) return -1;
  p.current=1;
  if(!generate_path(board,em,location,dest,size,pick,p)) p.current=p.length=0;
  }
mob::step(BYTE *d,int x) {
  if(p.data==NULL)
    return -1;
  if(d[p.data[p.current].x+p.data[p.current].y*x]!=5) {
    target.x=target.y=-1;       // some else is already there:
    p.current=0;
    p.length=0;
    if(p.data!=NULL) {
      delete [] p.data;
      p.data=NULL;
      }                                // so find path around them
    return -1;
    }
  d[location.x+location.y*x]=5; // Free the current square we were standing
                                // on.
  location.x=p.data[p.current].x;
  location.y=p.data[p.current++].y;

  d[location.x+location.y*x]=pict; // Place self on back on map.
  if(p.data[p.current].x==-1&&p.data[p.current].y==-1) {
    p.length=0;
    p.current=0;
    if(p.data!=NULL) {
      delete [] p.data;
      p.data=NULL;
      }
    }
  return 0;
  }
mob::mob(vect size) {
  if(orc!=NULL) {
    brain=scCreate_Instance(orc,"");
    if(brain!=NULL)
      scCall_Instance(brain,scGet_Symbol(brain,"init"),this,size);

    }
  else brain=NULL;
  id=total++;
  allignment=0;
  name[0]=0;
  dest.x=target.x=0;
  dest.y=target.y=0;
  current.life=normal.life;
  current.attack=normal.attack;
  current.defence=normal.defence;
  current.range=normal.range;
  current.skill=normal.skill;

  p.length=0;
  p.current=0;
  p.data=NULL;
  food=0;
  gold=0;
  exp=0;
  race=0;  // 0 Goblin 1 Human 2 Elf --- Order for now
  }

mob::~mob() {
  if(allignment!=0) scKill_Instance(brain);
  if(orc!=NULL) scFree_Instance(brain);

  if(p.data!=NULL)
    delete [] p.data;

  }


/////////////////////////// AI Part //////////////////////////////////
char *mobs=
"
struct vect {
  long int x,y;
  };
struct path {
  vect *data;
  int current;
  int length;
  };

struct stats {
  int attack;
  int defence;
  int skill;
  int range;
  int life;
  } ;
struct mob {
    char name[12];
    vect location;
    vect dest;
    vect target;
    int allignment;    // NOTE: if allignment is 0 then is a party member
    void *brain; //       else controlled by AI.
    int pict;
    path p;
    int food; // turns 'til hungry; if food == -10 subtract one life point per turn.
    int gold;
    int exp;
    int race;      // creature_type NOTE: this controls which AI to load
    stats normal;  // normal stats of creature.
    stats current; // current stats of creature.
    stats bonus;   // bonus gain by armor and weapon
    int id;
    int total;
  };
#define BYTE unsigned char

import int random(int x);
";
int random_(int x) {
  if(x==0) return 0;
  return (rand()%x);
  }
BYTE flag=0;

InitSc() {
  if(flag!=0) return -1; // Note only needs be called once each time running.
  flag=1;
  scAdd_External_Symbol("random",random_);
  scAdd_External_Symbol("sync",(void *)&sync);
  scAdd_External_Symbol("stardate",(void *)&stardate);
  scAdd_Internal_Header("mobs",mobs);
  ((char *)Mp_data[orc_ai].dat)[Mp_data[orc_ai].size-1]=0;
  orc=scCompile_Text((char *)Mp_data[orc_ai].dat);
  if (scErrorNo)
   {
   FILE *o=fopen("error.log","wt");
   fprintf(o,"%s\n> %s\n",scErrorMsg,scErrorLine);
   fclose(o);
   }
  }

KillSc() {
  if(flag!=1) return -1;
  flag=0;
  free(orc);
  }
