#ifndef MOBS_H
#define MOBS_H

int walk(BYTE square,int pick);

struct path {
  vect *data;
  int current;
  int length;
  };

struct stats {
  int attack;
  int defence;
  int skill;
  int range;
  int life;
  } ;

class mob {
  public:
    char name[12];
    vect location;
    vect dest;
    vect target;
    int allignment;    // NOTE: if allignment is 0 then is a party member
    scInstance *brain; //       else controlled by AI.
    int pict;
    path p;
    int food; // turns 'til hungry; if food == -10 subtract one life point per turn.
    int gold;
    int exp;
    int race;      // creature_type NOTE: this controls which AI to load
    stats normal;  // normal stats of creature.
    stats current; // current stats of creature.
    stats bonus;   // bonus gained by weapon + armor
    int id;
    static int total;
  public:
    mob(vect size);
    ~mob();
    do_stats();
    dis(BYTE *d,int s);
    go_to(BYTE *board,BYTE *em,int pick,vect size);
    step(BYTE *d,int x);

  } ;
InitSc();
KillSc();
#define none    -1
#define inf_use -1    // these must be rare and only do small things
#define armor   -2
#define weapon  -3
#define noget   -4
#define special -5

class item {
  public:
    char name[10];
    char type[10];
    stats use;
    int cost;       // cost of item to buy 5% less for sell
    int uses_left;  // if >0 then no of uses left else if <0 a flag for
                    // info about object
    int mob_holding;// ID of the mob holding the said item. ignore if -1
    union {
      vect location;  // location on map
      int useing;
      }  info;
    int pict;       // number of index of item picture
    int anim;       // number of frames in animation; must be 1 or greater
  public:
    dis(BYTE *d,int s,int i);
  };

#endif
